/*============================================================================*/
/*                        L a b W i n d o w s / C V I                         */
/*----------------------------------------------------------------------------*/
/*    Copyright (c) National Instruments 1987-1996.  All Rights Reserved.     */
/*----------------------------------------------------------------------------*/
/*                                                                            */
/* Title:       cvidef.h                                                      */
/* Purpose:     To define macros for for conditional header processing.       */
/*                                                                            */
/*============================================================================*/

#ifndef _CVIDEF_H
#define _CVIDEF_H

#ifdef __cplusplus
    extern "C" {
#endif


/*
 * Make all possible predefined macros agree
 */
#if (!defined(_NI_mswin16_)) && (defined(_NI_mswin32_)||defined(__WIN32__)||defined(__NT__)||defined(_WIN32)||defined(WIN32)) 
    #ifndef WIN32
        #define WIN32 1
    #endif
    #ifndef _NI_mswin32_
        #define _NI_mswin32_ 1
    #endif
#endif
#if defined(_NI_mswin16_) || defined(_NI_mswin32_)
    #ifndef _NI_i386_
        #define _NI_i386_ 1
    #endif
    #ifndef _NI_mswin_
        #define _NI_mswin_ 1
    #endif
#endif
#if defined(_NI_sparc_) || defined(_NI_hpux_)
    #ifndef _NI_unix_
        #define _NI_unix_ 1
    #endif
#endif

/*
 * Begining of WIN32 specific defines
 */
#ifdef _NI_mswin32_

    /* This is needed for borland 4.52. Starting with borland 5.0   */
    /* this is no longer necessary. The macro is used by instrument */
    /* drivers.                                                     */
    #if defined(__BORLANDC__) &&  (__BORLANDC__ < 0x500)
        #define DLLIMPORT __import
        #define DLLEXPORT __export
    #else 
        #define DLLIMPORT __declspec(dllimport)
        #define DLLEXPORT __declspec(dllexport)
    #endif

    /* If compiled with debugging use actual variables otherwise */
    /* use functions returning pointers to the variables.        */
    #ifndef _CVI_DEBUG_
        #define USE_FUNCS_FOR_VARS
    #endif

    /* All CDECL Functions are WCSTACK when using WC or cvi in WC COMPATIBILITY MODE */
    #if defined(__WATCOMC__) || defined(_NI_WC_)
        #define CVICDECL
    #else
        #define CVICDECL __cdecl
    #endif

    /* CVICALLBACK is used for typdefs for ptrs to functions. For example:
     *  typedef void (CVICALLBACK * MenuDimmerCallbackPtr)(int menuBar,  int panel);
     */
    #define CVICALLBACK     CVICDECL

    /* for function prototypes */
    #define CVIFUNC         __stdcall
    #define CVIFUNC_C       CVICDECL
    #define CVIANSI         CVICDECL

    #define CVIFUNCPTRVAR   __stdcall
    #define DLLSTDCALL      __stdcall

    
    #ifndef CVI_EXCLUDE_WINDOWS_TYPES
        /*****************************************************************/
        /* Constants from winnt.h for the fdwReason parameter of DllMain */
        /*****************************************************************/
        #ifndef DLL_PROCESS_ATTACH
        #define DLL_PROCESS_ATTACH 1    
        #endif
        #ifndef DLL_THREAD_ATTACH
        #define DLL_THREAD_ATTACH  2    
        #endif
        #ifndef DLL_THREAD_DETACH
        #define DLL_THREAD_DETACH  3    
        #endif
        #ifndef DLL_PROCESS_DETACH
        #define DLL_PROCESS_DETACH 0    
        #endif

        /************************************/
        /* Defines from winnt.h / winbase.h */
        /************************************/
        #ifndef _WINDEF_ /* a little safer (no warnings) */
            #if defined(STRICT) || defined(_CVI_)           
                struct HINSTANCE__;
                typedef struct HINSTANCE__  *HINSTANCE;
            #else
                typedef void                *HINSTANCE;
            #endif
            typedef int                     BOOL;
            typedef unsigned long           DWORD;
            typedef void                    *LPVOID;
        #endif
        #ifndef _WINNT_ /* a little safer (no warnings) */
            typedef char                    *LPSTR;
        #endif

    #endif  /* ndef CVI_EXCLUDE_WINDOWS_TYPES */
        
#else
/*
 * Begining of NON-WIN32 specific defines
 */

    #define DLLIMPORT 
    #define DLLEXPORT 
    #define CVIFUNC
    #define CVICALLBACK
    #define CVIFUNC_C
    #define CVIANSI
    #define CVIFUNCPTRVAR
    #define DLLSTDCALL   

#endif /* defined(_NI_mswin32_) (else clause) */

/*
 * Begining of defines which are always done
 */

#define cviprefix(c) CVI_ ## c



#ifdef __cplusplus
    }
#endif

#endif /* !defined(_CVIDEF_H) */
